]> git.ipfire.org Git - thirdparty/git.git/blame - git-filter-branch.sh
GIT 1.5.4-rc1
[thirdparty/git.git] / git-filter-branch.sh
CommitLineData
6f6826c5
JS
1#!/bin/sh
2#
3# Rewrite revision history
4# Copyright (c) Petr Baudis, 2006
5# Minimal changes to "port" it to core-git (c) Johannes Schindelin, 2007
6#
c401b33c
JS
7# Lets you rewrite the revision history of the current branch, creating
8# a new branch. You can specify a number of filters to modify the commits,
9# files and trees.
6f6826c5 10
16ed34ad
JS
11# The following functions will also be available in the commit filter:
12
13functions=$(cat << \EOF
b5669a05
SP
14warn () {
15 echo "$*" >&2
16}
17
6f6826c5
JS
18map()
19{
3520e1e8 20 # if it was not rewritten, take the original
c57a3494
JS
21 if test -r "$workdir/../map/$1"
22 then
23 cat "$workdir/../map/$1"
24 else
25 echo "$1"
26 fi
6f6826c5
JS
27}
28
f95eef15
JS
29# if you run 'skip_commit "$@"' in a commit filter, it will print
30# the (mapped) parents, effectively skipping the commit.
31
32skip_commit()
33{
34 shift;
35 while [ -n "$1" ];
36 do
37 shift;
38 map "$1";
39 shift;
40 done;
41}
42
8c1ce0f4
JS
43# override die(): this version puts in an extra line break, so that
44# the progress is still visible
45
46die()
47{
48 echo >&2
49 echo "$*" >&2
50 exit 1
51}
16ed34ad
JS
52EOF
53)
54
55eval "$functions"
8c1ce0f4 56
6f6826c5
JS
57# When piped a commit, output a script to set the ident of either
58# "author" or "committer
59
60set_ident () {
61 lid="$(echo "$1" | tr "A-Z" "a-z")"
62 uid="$(echo "$1" | tr "a-z" "A-Z")"
63 pick_id_script='
64 /^'$lid' /{
65 s/'\''/'\''\\'\'\''/g
66 h
67 s/^'$lid' \([^<]*\) <[^>]*> .*$/\1/
68 s/'\''/'\''\'\'\''/g
3addc94a 69 s/.*/GIT_'$uid'_NAME='\''&'\''; export GIT_'$uid'_NAME/p
6f6826c5
JS
70
71 g
72 s/^'$lid' [^<]* <\([^>]*\)> .*$/\1/
73 s/'\''/'\''\'\'\''/g
3addc94a 74 s/.*/GIT_'$uid'_EMAIL='\''&'\''; export GIT_'$uid'_EMAIL/p
6f6826c5
JS
75
76 g
77 s/^'$lid' [^<]* <[^>]*> \(.*\)$/\1/
78 s/'\''/'\''\'\'\''/g
3addc94a 79 s/.*/GIT_'$uid'_DATE='\''&'\''; export GIT_'$uid'_DATE/p
6f6826c5
JS
80
81 q
82 }
83 '
84
85 LANG=C LC_ALL=C sed -ne "$pick_id_script"
86 # Ensure non-empty id name.
3addc94a 87 echo "case \"\$GIT_${uid}_NAME\" in \"\") GIT_${uid}_NAME=\"\${GIT_${uid}_EMAIL%%@*}\" && export GIT_${uid}_NAME;; esac"
6f6826c5
JS
88}
89
7e0f1704
JS
90USAGE="[--env-filter <command>] [--tree-filter <command>] \
91[--index-filter <command>] [--parent-filter <command>] \
92[--msg-filter <command>] [--commit-filter <command>] \
93[--tag-name-filter <command>] [--subdirectory-filter <directory>] \
94[--original <namespace>] [-d <directory>] [-f | --force] \
95[<rev-list options>...]"
96
8f321a39 97OPTIONS_SPEC=
7e0f1704
JS
98. git-sh-setup
99
46eb449c 100git diff-files --quiet &&
38762c47 101 git diff-index --cached --quiet HEAD -- ||
46eb449c
JS
102 die "Cannot rewrite branch(es) with a dirty working directory."
103
6f6826c5 104tempdir=.git-rewrite
6f6826c5
JS
105filter_env=
106filter_tree=
107filter_index=
108filter_parent=
109filter_msg=cat
5be60078 110filter_commit='git commit-tree "$@"'
6f6826c5 111filter_tag_name=
685ef546 112filter_subdir=
dfd05e38
JS
113orig_namespace=refs/original/
114force=
822f7c73 115while :
6f6826c5 116do
822f7c73 117 test $# = 0 && usage
6f6826c5
JS
118 case "$1" in
119 --)
120 shift
121 break
122 ;;
dfd05e38
JS
123 --force|-f)
124 shift
125 force=t
126 continue
127 ;;
6f6826c5
JS
128 -*)
129 ;;
130 *)
131 break;
132 esac
133
134 # all switches take one argument
135 ARG="$1"
136 case "$#" in 1) usage ;; esac
137 shift
138 OPTARG="$1"
139 shift
140
141 case "$ARG" in
142 -d)
143 tempdir="$OPTARG"
144 ;;
6f6826c5
JS
145 --env-filter)
146 filter_env="$OPTARG"
147 ;;
148 --tree-filter)
149 filter_tree="$OPTARG"
150 ;;
151 --index-filter)
152 filter_index="$OPTARG"
153 ;;
154 --parent-filter)
155 filter_parent="$OPTARG"
156 ;;
157 --msg-filter)
158 filter_msg="$OPTARG"
159 ;;
160 --commit-filter)
16ed34ad 161 filter_commit="$functions; $OPTARG"
6f6826c5
JS
162 ;;
163 --tag-name-filter)
164 filter_tag_name="$OPTARG"
165 ;;
685ef546
JS
166 --subdirectory-filter)
167 filter_subdir="$OPTARG"
168 ;;
dfd05e38 169 --original)
55ced83d 170 orig_namespace=$(expr "$OPTARG/" : '\(.*[^/]\)/*$')/
dfd05e38 171 ;;
6f6826c5
JS
172 *)
173 usage
174 ;;
175 esac
176done
177
dfd05e38
JS
178case "$force" in
179t)
180 rm -rf "$tempdir"
181;;
182'')
183 test -d "$tempdir" &&
184 die "$tempdir already exists, please remove it"
185esac
af580e9c 186mkdir -p "$tempdir/t" &&
dfd05e38 187tempdir="$(cd "$tempdir"; pwd)" &&
af580e9c
JS
188cd "$tempdir/t" &&
189workdir="$(pwd)" ||
190die ""
6f6826c5 191
dfd05e38
JS
192# Make sure refs/original is empty
193git for-each-ref > "$tempdir"/backup-refs
194while read sha1 type name
195do
196 case "$force,$name" in
197 ,$orig_namespace*)
198 die "Namespace $orig_namespace not empty"
199 ;;
200 t,$orig_namespace*)
201 git update-ref -d "$name" $sha1
202 ;;
203 esac
204done < "$tempdir"/backup-refs
205
46eb449c
JS
206ORIG_GIT_DIR="$GIT_DIR"
207ORIG_GIT_WORK_TREE="$GIT_WORK_TREE"
208ORIG_GIT_INDEX_FILE="$GIT_INDEX_FILE"
3addc94a
JS
209GIT_WORK_TREE=.
210export GIT_DIR GIT_WORK_TREE
6f6826c5 211
dfd05e38
JS
212# These refs should be updated if their heads were rewritten
213
214git rev-parse --revs-only --symbolic "$@" |
215while read ref
216do
217 # normalize ref
218 case "$ref" in
219 HEAD)
220 ref="$(git symbolic-ref "$ref")"
221 ;;
222 refs/*)
223 ;;
224 *)
225 ref="$(git for-each-ref --format='%(refname)' |
226 grep /"$ref")"
227 esac
228
229 git check-ref-format "$ref" && echo "$ref"
230done > "$tempdir"/heads
231
232test -s "$tempdir"/heads ||
233 die "Which ref do you want to rewrite?"
234
3addc94a
JS
235GIT_INDEX_FILE="$(pwd)/../index"
236export GIT_INDEX_FILE
af580e9c 237git read-tree || die "Could not seed the index"
6f6826c5
JS
238
239ret=0
240
af580e9c
JS
241# map old->new commit ids for rewriting parents
242mkdir ../map || die "Could not create map/ directory"
6f6826c5 243
685ef546
JS
244case "$filter_subdir" in
245"")
5be60078 246 git rev-list --reverse --topo-order --default HEAD \
813b4734 247 --parents "$@"
685ef546
JS
248 ;;
249*)
5be60078 250 git rev-list --reverse --topo-order --default HEAD \
cfabd6ee 251 --parents --full-history "$@" -- "$filter_subdir"
af580e9c 252esac > ../revs || die "Could not get the commits"
9d6f220c 253commits=$(wc -l <../revs | tr -d " ")
6f6826c5
JS
254
255test $commits -eq 0 && die "Found nothing to rewrite"
256
dfd05e38
JS
257# Rewrite the commits
258
6f6826c5 259i=0
813b4734 260while read commit parents; do
c12764b8 261 i=$(($i+1))
5efb48b5 262 printf "\rRewrite $commit ($i/$commits)"
6f6826c5 263
685ef546
JS
264 case "$filter_subdir" in
265 "")
5be60078 266 git read-tree -i -m $commit
685ef546
JS
267 ;;
268 *)
5be60078 269 git read-tree -i -m $commit:"$filter_subdir"
af580e9c 270 esac || die "Could not initialize the index"
6f6826c5 271
3addc94a
JS
272 GIT_COMMIT=$commit
273 export GIT_COMMIT
af580e9c
JS
274 git cat-file commit "$commit" >../commit ||
275 die "Cannot read commit $commit"
6f6826c5 276
8c1ce0f4
JS
277 eval "$(set_ident AUTHOR <../commit)" ||
278 die "setting author failed for commit $commit"
279 eval "$(set_ident COMMITTER <../commit)" ||
280 die "setting committer failed for commit $commit"
281 eval "$filter_env" < /dev/null ||
282 die "env filter failed: $filter_env"
6f6826c5
JS
283
284 if [ "$filter_tree" ]; then
af580e9c
JS
285 git checkout-index -f -u -a ||
286 die "Could not checkout the index"
6f6826c5
JS
287 # files that $commit removed are now still in the working tree;
288 # remove them, else they would be added again
5be60078 289 git ls-files -z --others | xargs -0 rm -f
8c1ce0f4
JS
290 eval "$filter_tree" < /dev/null ||
291 die "tree filter failed: $filter_tree"
292
e8a3f909 293 git diff-index -r $commit | cut -f 2- | tr '\012' '\000' | \
5be60078
JH
294 xargs -0 git update-index --add --replace --remove
295 git ls-files -z --others | \
296 xargs -0 git update-index --add --replace --remove
6f6826c5
JS
297 fi
298
8c1ce0f4
JS
299 eval "$filter_index" < /dev/null ||
300 die "index filter failed: $filter_index"
6f6826c5
JS
301
302 parentstr=
813b4734 303 for parent in $parents; do
3520e1e8
JS
304 for reparent in $(map "$parent"); do
305 parentstr="$parentstr -p $reparent"
306 done
6f6826c5
JS
307 done
308 if [ "$filter_parent" ]; then
8c1ce0f4
JS
309 parentstr="$(echo "$parentstr" | eval "$filter_parent")" ||
310 die "parent filter failed: $filter_parent"
6f6826c5
JS
311 fi
312
313 sed -e '1,/^$/d' <../commit | \
8c1ce0f4
JS
314 eval "$filter_msg" > ../message ||
315 die "msg filter failed: $filter_msg"
316 sh -c "$filter_commit" "git commit-tree" \
317 $(git write-tree) $parentstr < ../message > ../map/$commit
6f6826c5
JS
318done <../revs
319
dfd05e38
JS
320# In case of a subdirectory filter, it is possible that a specified head
321# is not in the set of rewritten commits, because it was pruned by the
322# revision walker. Fix it by mapping these heads to the next rewritten
323# ancestor(s), i.e. the boundaries in the set of rewritten commits.
324
325# NEEDSWORK: we should sort the unmapped refs topologically first
326while read ref
327do
328 sha1=$(git rev-parse "$ref"^0)
329 test -f "$workdir"/../map/$sha1 && continue
330 # Assign the boundarie(s) in the set of rewritten commits
331 # as the replacement commit(s).
332 # (This would look a bit nicer if --not --stdin worked.)
24d00634 333 for p in $( (cd "$workdir"/../map; ls | sed "s/^/^/") |
dfd05e38
JS
334 git rev-list $ref --boundary --stdin |
335 sed -n "s/^-//p")
336 do
337 map $p >> "$workdir"/../map/$sha1
338 done
339done < "$tempdir"/heads
340
341# Finally update the refs
342
343_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
344_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
dfd05e38
JS
345echo
346while read ref
347do
348 # avoid rewriting a ref twice
349 test -f "$orig_namespace$ref" && continue
350
351 sha1=$(git rev-parse "$ref"^0)
352 rewritten=$(map $sha1)
353
354 test $sha1 = "$rewritten" &&
355 warn "WARNING: Ref '$ref' is unchanged" &&
356 continue
357
358 case "$rewritten" in
359 '')
360 echo "Ref '$ref' was deleted"
361 git update-ref -m "filter-branch: delete" -d "$ref" $sha1 ||
362 die "Could not delete $ref"
98409060 363 ;;
dfd05e38
JS
364 $_x40)
365 echo "Ref '$ref' was rewritten"
366 git update-ref -m "filter-branch: rewrite" \
367 "$ref" $rewritten $sha1 ||
368 die "Could not rewrite $ref"
98409060 369 ;;
dfd05e38
JS
370 *)
371 # NEEDSWORK: possibly add -Werror, making this an error
372 warn "WARNING: '$ref' was rewritten into multiple commits:"
373 warn "$rewritten"
374 warn "WARNING: Ref '$ref' points to the first one now."
375 rewritten=$(echo "$rewritten" | head -n 1)
376 git update-ref -m "filter-branch: rewrite to first" \
377 "$ref" $rewritten $sha1 ||
378 die "Could not rewrite $ref"
379 ;;
380 esac
381 git update-ref -m "filter-branch: backup" "$orig_namespace$ref" $sha1
dfd05e38
JS
382done < "$tempdir"/heads
383
384# TODO: This should possibly go, with the semantics that all positive given
385# refs are updated, and their original heads stored in refs/original/
386# Filter tags
6f6826c5
JS
387
388if [ "$filter_tag_name" ]; then
5be60078 389 git for-each-ref --format='%(objectname) %(objecttype) %(refname)' refs/tags |
6f6826c5
JS
390 while read sha1 type ref; do
391 ref="${ref#refs/tags/}"
392 # XXX: Rewrite tagged trees as well?
393 if [ "$type" != "commit" -a "$type" != "tag" ]; then
394 continue;
395 fi
396
397 if [ "$type" = "tag" ]; then
398 # Dereference to a commit
399 sha1t="$sha1"
5be60078 400 sha1="$(git rev-parse "$sha1"^{commit} 2>/dev/null)" || continue
6f6826c5
JS
401 fi
402
403 [ -f "../map/$sha1" ] || continue
404 new_sha1="$(cat "../map/$sha1")"
3addc94a
JS
405 GIT_COMMIT="$sha1"
406 export GIT_COMMIT
8c1ce0f4
JS
407 new_ref="$(echo "$ref" | eval "$filter_tag_name")" ||
408 die "tag name filter failed: $filter_tag_name"
6f6826c5
JS
409
410 echo "$ref -> $new_ref ($sha1 -> $new_sha1)"
411
412 if [ "$type" = "tag" ]; then
413 # Warn that we are not rewriting the tag object itself.
414 warn "unreferencing tag object $sha1t"
415 fi
416
af580e9c
JS
417 git update-ref "refs/tags/$new_ref" "$new_sha1" ||
418 die "Could not write tag $new_ref"
6f6826c5
JS
419 done
420fi
421
422cd ../..
423rm -rf "$tempdir"
6f6826c5 424
46eb449c
JS
425unset GIT_DIR GIT_WORK_TREE GIT_INDEX_FILE
426test -z "$ORIG_GIT_DIR" || GIT_DIR="$ORIG_GIT_DIR" && export GIT_DIR
427test -z "$ORIG_GIT_WORK_TREE" || GIT_WORK_TREE="$ORIG_GIT_WORK_TREE" &&
428 export GIT_WORK_TREE
429test -z "$ORIG_GIT_INDEX_FILE" || GIT_INDEX_FILE="$ORIG_GIT_INDEX_FILE" &&
430 export GIT_INDEX_FILE
431git read-tree -u -m HEAD
432
6f6826c5 433exit $ret